POJ 3691 DNA repair (AC自动机 + dp)

177 篇文章 0 订阅
129 篇文章 0 订阅
DNA repair
Time Limit: 2000MS Memory Limit: 65536K
Total Submissions: 6014 Accepted: 2820

Description

Biologists finally invent techniques of repairing DNA that contains segments causing kinds of inherited diseases. For the sake of simplicity, a DNA is represented as a string containing characters 'A', 'G' , 'C' and 'T'. The repairing techniques are simply to change some characters to eliminate all segments causing diseases. For example, we can repair a DNA "AAGCAG" to "AGGCAC" to eliminate the initial causing disease segments "AAG", "AGC" and "CAG" by changing two characters. Note that the repaired DNA can still contain only characters 'A', 'G', 'C' and 'T'.

You are to help the biologists to repair a DNA by changing least number of characters.

Input

The input consists of multiple test cases. Each test case starts with a line containing one integers  N (1 ≤  N ≤ 50), which is the number of DNA segments causing inherited diseases.
The following  N lines gives  N non-empty strings of length not greater than 20 containing only characters in "AGCT", which are the DNA segments causing inherited disease.
The last line of the test case is a non-empty string of length not greater than 1000 containing only characters in "AGCT", which is the DNA to be repaired.

The last test case is followed by a line containing one zeros.

Output

For each test case, print a line containing the test case number( beginning with 1) followed by the
number of characters which need to be changed. If it's impossible to repair the given DNA, print -1.

Sample Input

2
AAA
AAG
AAAG    
2
A
TG
TGAATG
4
A
G
C
T
AGT
0

Sample Output

Case 1: 1
Case 2: 4
Case 3: -1

Source

2008 Asia Hefei Regional Contest Online by USTC


题目链接:http://poj.org/problem?id=3691


题目大意:给一些坏的字符串,要求主串中不出现坏的字符串,问最少要改变几个主串中的字符


题目分析:将问题变为在 AC机上走(不走过危险结点),使得走过的路径得到的串与目标串匹配最多,建AC机的时候如果一个点失败指针指的点是坏点,那它也是坏点,相当于这个坏字符串是另一个的子串,这里还需要用Trie图优化,方便dp时候状态的转移,dp[i][j]表示主串匹配了前i个字符且自动机在j结点时最少要改变的字符数,注意dp的时候要避开坏点

#include <cstdio>
#include <cstring>
#include <queue>
#include <algorithm>
using namespace std;
int const MAX = 1005;
int const INF = 1 << 30;
char s[50], t[MAX];

struct AC_DP
{
	int tot, root, fail[MAX], next[MAX][4];
	int dp[MAX][MAX];
	bool bad[MAX];

	inline int chg(char ch)
	{
		if(ch == 'A')
			return 0;
		if(ch == 'T')
			return 1;
		if(ch == 'C')
			return 2;
		return 3;
	}

	inline int Newnode()
	{
		for(int i = 0; i < 4; i++)
			next[tot][i] = -1;
		fail[tot] = 0;
		bad[tot] = false;
		return tot ++;
	}

	inline void Init()
	{
		tot = 0;
		root = Newnode();
	}

	inline void Insert(char *s)
	{
		int len = strlen(s);
		int p = root;
		for(int i = 0; i < len; i++)
		{
			int idx = chg(s[i]);
			if(next[p][idx] == -1)
				next[p][idx] = Newnode();
			p = next[p][idx];
		}
		bad[p] = true;
	}

	inline void Build()
	{
		queue <int> q;
		q.push(root);
		while(!q.empty())
		{
			int p = q.front();
			q.pop();
			for(int i = 0; i < 4; i++)
			{
				if(next[p][i] == -1)
				{
					if(p == root)
						next[p][i] = root;
					else
						next[p][i] = next[fail[p]][i];
				}
				else
				{
					if(p == root)
						fail[next[p][i]] = root;
					else
					{
						fail[next[p][i]] = next[fail[p]][i];
						bad[p] |= bad[fail[p]];
					}
					q.push(next[p][i]);
				}
			}
		}
	}

	inline int DP()
	{
		int tlen = strlen(t);
		int ans = INF;
		for(int i = 0; i <= tlen; i++)
			for(int j = 0; j < tot; j++)
				dp[i][j] = INF;
		dp[0][0] = 0;
		for(int i = 1; i <= tlen; i++)
			for(int j = 0; j < tot; j++)
				if(dp[i - 1][j] < INF)
					for(int k = 0; k < 4; k++)
						if(!bad[next[j][k]])
							dp[i][next[j][k]] = min(dp[i][next[j][k]], dp[i - 1][j] + (chg(t[i - 1]) != k));
		for(int j = 0; j < tot; j++)
			if(!bad[j])
				ans = min(ans, dp[tlen][j]);
		if(ans == INF)
			return -1;
		return ans;
	}	
}ac;

int main()
{
	int n, ca = 1;
	while(scanf("%d", &n) != EOF && n)
	{
		ac.Init();
		for(int i = 0; i < n; i++)
		{
			scanf("%s", s);
			ac.Insert(s);
		}
		scanf("%s", t);	
		ac.Build();
		printf("Case %d: %d\n", ca ++, ac.DP());
	}
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给出一个$n\times m$的矩阵,每个位置上有一个非负整数,代表这个位置的海拔高度。一开始时,有一个人站在其中一个位置上。这个人可以向上、下、左、右四个方向移动,但是只能移动到海拔高度比当前位置低或者相等的位置上。一次移动只能移动一个单位长度。定义一个位置为“山顶”,当且仅当从这个位置开始移动,可以一直走到海拔高度比它低的位置上。请问,这个矩阵中最多有多少个“山顶”? 输入格式 第一行两个整数,分别表示$n$和$m$。 接下来$n$行,每行$m$个整数,表示整个矩阵。 输出格式 输出一个整数,表示最多有多少个“山顶”。 样例输入 4 4 3 2 1 4 2 3 4 3 5 6 7 8 4 5 6 7 样例输出 5 算法1 (递归dp) $O(nm)$ 对于这道题,我们可以使用递归DP来解决,用$f(i,j)$表示以$(i,j)$为起点的路径最大长度,那么最后的答案就是所有$f(i,j)$中的最大值。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码 算法2 (动态规划) $O(nm)$ 动态规划的思路与递归DP类似,只不过转移方程和实现方式有所不同。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值